diff --git a/Scanner.p b/Scanner.p
index 7b2a3a5..6ef0ca6 100644
--- a/Scanner.p
+++ b/Scanner.p
@@ -585,10 +585,11 @@ if list or (numErr <> 0) then begin
         110: emsg := 'lint: unknown pragma';
         111: emsg := 'the & operator cannot be applied to arrays';
         112: emsg := 'segment buffer overflow';
-        113: emsg := 'implementaion restriction: unsupported operation';
-        114: emsg := 'implementaion restriction: identifiers are limited to 255 characters';
+        113: emsg := 'implementation restriction: unsupported operation';
+        114: emsg := 'implementation restriction: identifiers are limited to 255 characters';
         115: emsg := 'a character constant must contain 1 or 2 characters';
-        116: emsg := 'implementaion restriction: -i and -l arguments are too long';
+        116: emsg := 'implementation restriction: -i and -l arguments are too long';
+        119: emsg := 'invalid digit for binary constant';
          otherwise Error(57);
          end; {case}
        writeln(emsg);
@@ -2680,6 +2681,7 @@ label 1;
 var
    c2: char;                            {next character to process}
    i: integer;                          {loop index}
+   isBin: boolean;                      {is the value a binary number?}
    isHex: boolean;                      {is the value a hex number?}
    isLong: boolean;                     {is the value a long number?}
    isReal: boolean;                     {is the value a real number?}
@@ -2785,13 +2787,15 @@ if c2 = '.' then begin                  {handle the case of no leading digits}
    end {if}
 else begin
    GetDigits;                           {read the leading digit stream}
-   if c2 in ['x','X'] then              {detect hex numbers}
+   if c2 in ['x','X', 'b', 'B'] then              {detect hex/binary numbers}
       if stringIndex = 1 then
          if numString[1] = '0' then begin
             stringIndex := 2;
-            numString[2] := 'X';
+            c2 := chr(BAnd(ord(c2), $5F));
+            numString[2] := c2;
+            if c2 = 'X' then isHex := true;
+            if c2 = 'B' then isBin := true;
             NextChar;
-            isHex := true;
             GetDigits;
             goto 1;
             end; {if}
@@ -2890,7 +2894,7 @@ else if numString[1] <> '0' then begin {convert a decimal integer}
       token.ival := Convertsl(numString);
       end; {else}
    end {else if}
-else begin                            {hex & octal}
+else begin                            {hex, binary, & octal}
    token.lval := 0;
    if isHex then begin
       i := 3;
@@ -2910,6 +2914,22 @@ else begin                            {hex & octal}
             end; {else}
          end; {while}
       end {if}
+   else if isBin then begin
+      i := 3;
+      while i <= length(numString) do begin
+         if BAnd(token.lval, $80000000) <> 0 then begin
+            i := maxint;
+            if flagOverflows then
+               Error(6);
+            end {if}
+         else begin
+            if not (numString[i] in ['0', '1']) then
+                Error(119);
+            token.lval := BOr(BSL(token.lval, 1), BAnd(ord(numString[i]), $0001));
+            i := i+1;
+            end; {else}
+         end; {while}
+      end {if}
    else begin
       i := 1;
       while i <= length(numString) do begin
